/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License") you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code in this file was released April 1, 2001
 * 
 * The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
 * all Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
 * by Henk-Johan van Rantwijk. All Rights Reserved.
 * 
 * Contributor(s):
 *   Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
 *   David Perry <d.perry@utoronto.ca>
 *   Neil Pryde <NeilPryde92651@netscape.net> (well I'm just HJ's typewriter)
 * 
 */

var newPrefsAdded = 0;
var prefErrors = 0;
var mvPreference = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPrefBranch);

////////////////////////////////////////////////////////////////////////////////
// This function initializes the preferences for MultiZilla. It writes a new 
// pref setting in case it is missing.
////////////////////////////////////////////////////////////////////////////////
function initPreferences()
{
  if (readMyPref("multizilla.prefs.checked", "bool", false))
    return; // Bail out if already checked. This will improve our startup time

  // -- prefs.js --------------------------------------------------------------------------------
  readMyPref("multizilla.bookmark.close-remaining", "bool", false);
  readMyPref("multizilla.bookmark.folders", "int", 15);
  readMyPref("multizilla.bookmark.groups", "int", 15);
  // readMyPref("multizilla.bookmark.items", "int", 0); removed in MultiZilla v1.5
  readMyPref("multizilla.bookmark.loadInBackground", "bool", false);
  readMyPref("multizilla.bookmark.menuitem.allow-middleclick", "bool", true);
  readMyPref("multizilla.bookmark.menuitem.middleclick-closepopups", "bool", true);
  readMyPref("multizilla.check.webtools", "bool", true);  
  readMyPref("multizilla.confirm.quit", "int", 11);
  readMyPref("multizilla.dnd.loadInBackground", "bool", false);
  readMyPref("multizilla.dnd.tabstripdrops.selected", "bool", true);
  readMyPref("multizilla.forced.autocomplete", "bool", true);
  readMyPref("multizilla.forced.onsubmit-remove", "bool", false);
  readMyPref("multizilla.fullscreen.enabled", "bool", true);
  readMyPref("multizilla.fullscreen.enable.menubar", "bool", false);
  readMyPref("multizilla.fullscreen.enable.personaltoolbar", "bool", false);
  readMyPref("multizilla.fullscreen.enable.status-bar", "bool", true);
  // readMyPref("multizilla.fullscreen.enable.[toolbar id]", "bool", [true/false]);
  readMyPref("multizilla.fullscreen.first-browserwindow-only", "bool", true);
  readMyPref("multizilla.fullscreen.disable.chromeless", "bool", true);
  readMyPref("multizilla.fullscreen.enable.linktoolbar", "bool", false);
  readMyPref("multizilla.fullscreen.re-enable-chrome", "bool", true);
  readMyPref("multizilla.integrated.toolbar", "bool", false);
  readMyPref("multizilla.mouse-middle-click.close", "bool", true);
  readMyPref("multizilla.tabstrip.middle-click-action", "int", 0);
  readMyPref("multizilla.newtabfor.bookmarks", "bool", false);
  readMyPref("multizilla.newtabfor.ctrl-n", "bool", true);
  readMyPref("multizilla.newtabfor.groupfolders", "int", 0);
  readMyPref("multizilla.newtabfor.locationbar", "bool", false);
  readMyPref("multizilla.newtabfor.mailnews", "bool", false);
  readMyPref("multizilla.newtabfor.personal-toolbar", "bool", false);
  readMyPref("multizilla.newtabfor.sidebar", "bool", false);
  readMyPref("multizilla.newtabfor.view-source", "bool", true);
  readMyPref("multizilla.newtabfor.windowopen", "bool", true);
  readMyPref("multizilla.preferred.actual", "bool", false);
  readMyPref("multizilla.preferred.fornewtabs", "bool", false);
  readMyPref("multizilla.preferred.location", "string", "http://multizilla.mozdev.org/index.html");
  readMyPref("multizilla.preferred.type", "int", 0);
  readMyPref("multizilla.prevent.double", "bool", true);
  readMyPref("multizilla.refspoof.spoofing", "int", 1)
  readMyPref("multizilla.refspoof.spoofurl", "url", "http://ref.spoof.org/refspoof.cgi");
  readMyPref("multizilla.showbutton.clearlocbar", "bool", false);
  readMyPref("multizilla.showbutton.closeAll", "bool", true);
  readMyPref("multizilla.showbutton.closeOther", "bool", true);
  readMyPref("multizilla.showbutton.closeThis", "bool", true);
  readMyPref("multizilla.showbutton.inspector", "bool", true);
  readMyPref("multizilla.showbutton.jsconsole", "bool", true);
  readMyPref("multizilla.showbutton.newtab", "bool", true);
  readMyPref("multizilla.showbutton.qpmenu", "bool", false);
  readMyPref("multizilla.showbutton.quickprefmenu", "bool", true);
  readMyPref("multizilla.showbutton.tablist", "bool", true);
  readMyPref("multizilla.showbutton.tabpos", "bool", true);
  readMyPref("multizilla.showbutton.tabstrip", "bool", true);
  readMyPref("multizilla.showbutton.update", "bool", true);
  readMyPref("multizilla.tabbar.closebutton", "bool", false);
  readMyPref("multizilla.tabbar.newbutton", "bool", false);
  readMyPref("multizilla.tabs.andnotblank", "bool", true);
  readMyPref("multizilla.tabs.blank-tab-first", "bool", true);
  readMyPref("multizilla.tabs.confirm-close", "bool", true);
  readMyPref("multizilla.tabs.confirm-close-other", "bool", true);
  readMyPref("multizilla.tabs.focus-order", "int", 0);
  readMyPref("multizilla.tabs.groupmark", "string", "");
  readMyPref("multizilla.tabs.iconclose", "bool", true);
  readMyPref("multizilla.tabs.insertstyle", "int", 1);
  readMyPref("multizilla.tabs.mintabwidth", "int", 25);
  readMyPref("multizilla.tabs.meta-refresh", "int", 0);
  readMyPref("multizilla.tabs.ontop", "bool", true);
  readMyPref("multizilla.tabs.open-order", "int", 0);
  readMyPref("multizilla.tabs.saveonexit", "bool", true);
  readMyPref("multizilla.tabs.startgroup", "bool", true);
  readMyPref("multizilla.tabs.status-leds", "bool", true);
  readMyPref("multizilla.tabs.tabwidth", "int", 175);
  readMyPref("multizilla.tabs.title", "bool", true);
  readMyPref("multizilla.tabstrip.middle-click-opentab", "int", 0);

  var mPrefChecked = (newPrefsAdded == 0);
  writePref("bool", "multizilla.prefs.checked", mPrefChecked);
  if (prefErrors)
    alert("Error: corrupted pref settings detected, restart needed!");
}
////////////////////////////////////////////////////////////////////////////////
// this function returns true, false or the value for the given pref setting
////////////////////////////////////////////////////////////////////////////////
function readMyPref(prefIdentifier, prefType, defaultSetup)
{
  var prefValue;

  switch(prefType)
    {
      case "bool": 
        {
          try {
            prefValue = mvPreference.getBoolPref(prefIdentifier); 
          }
          catch(ex) {
            fixWrongPrefSetting(prefType, prefIdentifier, defaultSetup)
            return (defaultSetup);
          }
          if (prefValue || !prefValue) 
            return (prefValue);
          else return (defaultSetup);
        }
      case "int":
        {
          try {
            prefValue = mvPreference.getIntPref(prefIdentifier);
          }
          catch(ex) {
            fixWrongPrefSetting(prefType, prefIdentifier, defaultSetup)
            return (defaultSetup);
          }
          return (prefValue);
        }
      case "string":
        {
          try {
            prefValue = mvPreference.getComplexValue(prefIdentifier, Components.interfaces.nsISupportsString);
          }
          catch(ex) {
            fixWrongPrefSetting(prefType, prefIdentifier, defaultSetup)
            return (defaultSetup);
          }
          return prefValue.data.length ? prefValue.data : defaultSetup;
        }
      case "char":
        {
          try {
            prefValue = mvPreference.getCharPref(prefIdentifier);
          }
          catch(ex) {
            fixWrongPrefSetting(prefType, prefIdentifier, defaultSetup)
            return (defaultSetup);
          }
	      break;
        }
      case "url":
        {
          try {
            prefValue = mvPreference.getComplexValue(prefIdentifier, Components.interfaces.nsIPrefLocalizedString);
          }
          catch(ex) {
            fixWrongPrefSetting(prefType, prefIdentifier, defaultSetup)
            return (defaultSetup);
          }
          return prefValue.data.length ? prefValue.data : defaultSetup;
        }
      default:
        {
          dump('readMyPref(): Unsupported pref type "'+prefType+'" used\n');
        }
    }
  return (prefValue);
}
////////////////////////////////////////////////////////////////////////////////
function fixWrongPrefSetting(prefType, prefIdentifier, defaultSetup) 
{
  if (mvPreference.prefHasUserValue(prefIdentifier)) {
    mvPreference.clearUserPref(prefIdentifier);
    dump("\nError: prefType = "+prefType+"\nPrefIdentifier = "+prefIdentifier+"\nprefValue = "+defaultSetup);
    prefErrors++;
  }
  writePref(prefType, prefIdentifier, defaultSetup);
  newPrefsAdded++;
}
////////////////////////////////////////////////////////////////////////////////
// this function write the given preference type, 
////////////////////////////////////////////////////////////////////////////////
function writePref(prefType, prefString, prefValue)
{
  try {
    switch (prefType) {
      case "bool":
        {
          mvPreference.setBoolPref(prefString, prefValue);
          break;
        }
      case "int":
        {
          mvPreference.setIntPref(prefString, prefValue);
          break;
        }
      case "string":
        {
          var str;
          str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
          str.data = prefValue;
          mvPreference.setComplexValue(prefString, Components.interfaces.nsISupportsString, str);
          break;
        }
      case "url":
        {
          mvPreference.setComplexValue(prefString, Components.interfaces.nsIPrefLocalizedString, prefValue);
          break;
        }
      case "char":
        {
          mvPreference.setCharPref(prefString, prefValue);
          break;
        }
      default:
        {
          dump('writePref(): Unsupported pref type "'+prefType+'" used\n');
        }
    }
  }
  catch (ex) { // die silently 
  }
}
////////////////////////////////////////////////////////////////////////////////
function toggleBoolPref(aPrefIdentifier, aPrefType, aDefaultValue)
{
  var aPrefValue = readMyPref(aPrefIdentifier, aPrefType, aDefaultValue);
  writePref(aPrefType, aPrefIdentifier, !aPrefValue);
}
////////////////////////////////////////////////////////////////////////////////
// this function adds a small string to the useragent to identify MultiZilla
////////////////////////////////////////////////////////////////////////////////
function setIdentifier()
{
  var identifier = readMyPref("general.useragent.misc", "string", "");
  var version = getBrowser().mVersion;
  var rev = getBrowser().mVersionRev;
  if (identifier == "" || identifier.search("MultiZilla v") == -1)
    writePref("string", "general.useragent.misc", identifier + "; MultiZilla v" + version + rev, true);
}
////////////////////////////////////////////////////////////////////////////////
// this function adds a small string to the useragent to identify MultiZilla
////////////////////////////////////////////////////////////////////////////////
function removeIdentifier()
{
  var identifier = readMyPref("general.useragent.misc", "string", "");
  if (isFirstWindow() && identifier.search("MultiZilla v") != -1) {
    var startPos = identifier.search("rv:")
    identifier = identifier.substr(startPos, startPos + identifier.indexOf(";"));
    writePref("string", "general.useragent.misc", identifier, true);
  }
}

